#pragma once
 
using namespace System;
using namespace System::ComponentModel;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
using namespace AddinExpress::IE;
 
namespace AutoHideAB_Cpp
{
    //Add-in Express for Internet Explorer Module
    [ComVisible(true), GuidAttribute("5BF46CF8-F5FA-4E4B-B501-24B03D37FAAB")]
    public ref class IEModule : public AddinExpress::IE::ADXIEModule
    {
    public:
        IEModule(void)
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        IEModule(IContainer^ container)
        {
            container->Add(this);
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
    public:
        virtual System::ComponentModel::IContainer^ GetContainer() override;
 
        [ComRegisterFunctionAttribute]
        static void RegisterIEModule(System::Type^ t);
 
        [ComUnregisterFunctionAttribute]
        static void UnregisterIEModule(System::Type^ t);
 
        [ComVisible(true)]
        ref class IECustomContextMenuCommands :
            public AddinExpress::IE::ADXIEModule::ADXIEContextMenuCommandDispatcher
        {
        };
 
        [ComVisible(true)]
        ref class IECustomCommands :
            public AddinExpress::IE::ADXIEModule::ADXIECommandDispatcher
        {
        };
 
        inline Interop::SHDocVw::WebBrowser^ IEApp()
        {
            return dynamic_cast<Interop::SHDocVw::WebBrowser^>(IEObj);
        }
 
        inline mshtml::HTMLDocument^ HTMLDocument()
        {
            return dynamic_cast<mshtml::HTMLDocument^>(HTMLDocumentObj);
        }

 
    protected:
        ~IEModule()
        {
            if (components)
            {
                delete components;
            }
        }
	private: AddinExpress::IE::ADXIEAdvancedBarsManager^  adxieAdvancedBarsManager1;
	private: AddinExpress::IE::ADXIEAdvancedBarItem^  adxieAdvancedBarItem1;
	private: AddinExpress::IE::ADXIEHTMLDocEvents^  adxiehtmlDocEvents1;
	protected: 
	private: System::ComponentModel::IContainer^  components;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>

 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			this->components = (gcnew System::ComponentModel::Container());
			this->adxieAdvancedBarsManager1 = (gcnew AddinExpress::IE::ADXIEAdvancedBarsManager(this->components));
			this->adxieAdvancedBarItem1 = (gcnew AddinExpress::IE::ADXIEAdvancedBarItem(this->components));
			this->adxiehtmlDocEvents1 = (gcnew AddinExpress::IE::ADXIEHTMLDocEvents(this->components));
			// 
			// adxieAdvancedBarsManager1
			// 
			this->adxieAdvancedBarsManager1->Bars->Add(this->adxieAdvancedBarItem1);
			// 
			// adxieAdvancedBarItem1
			// 
			this->adxieAdvancedBarItem1->AllowAutoHide = true;
			this->adxieAdvancedBarItem1->BarType = L"AutoHideAB_Cpp.MyIEAdvancedBar1";
			this->adxieAdvancedBarItem1->Id = L"{A489762A-C07E-495D-82DF-90A659A50855}";
			this->adxieAdvancedBarItem1->MenuText = L"Auto Hide Example (C++)";
			this->adxieAdvancedBarItem1->Visible = true;
			// 
			// adxiehtmlDocEvents1
			// 
			this->adxiehtmlDocEvents1->SupportedEvents = AddinExpress::IE::ADXIEHTMLSupportedEvents::seWindow;
			this->adxiehtmlDocEvents1->OnScroll += gcnew AddinExpress::IE::ADXIEHTMLEventObject_EventHandler(this, &IEModule::adxiehtmlDocEvents1_OnScroll);
			// 
			// IEModule
			// 
			this->HandleShortcuts = true;
			this->LoadInMainProcess = false;
			this->ModuleName = L"AutoHideAB_Cpp";

		}
	private: System::Void adxiehtmlDocEvents1_OnScroll(System::Object^  sender, System::Object^  eventObject) {
				 if (eventObject != nullptr)
				 {
					 mshtml::IHTMLElement2^ pRoot = dynamic_cast<mshtml::IHTMLElement2^>(HTMLDocument()->documentElement);
					 if (pRoot != nullptr)
					 {
						MessageBox::Show(pRoot->scrollTop.ToString());
					 }
				 }
			 }
};
}

